
#ifndef SCANNED_SEQUENCE_H
#define SCANNED_SEQUENCE_H

typedef struct scanned_site SCANNED_SITE_T;
struct scanned_site {
  int m_num;
  char strand;
  long position;
  double pvalue;
};

typedef struct scanned_seq SCANNED_SEQ_T;
struct scanned_seq {
  char *seq_id;
  long length;
  double pvalue;
  long site_count;
  SCANNED_SITE_T *sites;
};

/*
 * Create a scanned sequence structure.
 * The seq_id is copied.
 */
SCANNED_SEQ_T* sseq_create(const char *seq_id, long length, double pvalue, 
    long site_count);

/*
 * Destroy the scanned sequence structure and all included scanned 
 * site structures.
 */
void sseq_destroy(void *sseq);

/*
 * Set the scanned site at a offset. 
 */
void sseq_set(SCANNED_SEQ_T *sseq, int index, int m_num,
    char strand, long position, double pvalue);

#endif
